SystemOrganization addCategory: #ConfigurationOfVersionner!

Object subclass: #ConfigurationOfVersionner
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfVersionner'!

!ConfigurationOfVersionner class methodsFor: 'development support' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfVersionner class methodsFor: 'private' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfVersionner class methodsFor: 'private' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfVersionner class methodsFor: 'private' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfVersionner class methodsFor: 'metacello tool support' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfVersionner class methodsFor: 'loading' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfVersionner class methodsFor: 'loading' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfVersionner class methodsFor: 'loading' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfVersionner class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
project

	^self new project! !

!ConfigurationOfVersionner class methodsFor: 'development support' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfVersionner methodsFor: 'baselines' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 12:14'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Versionner'.
		spec 
			package: 'Versionner-Core-Model';
			package: 'Versionner-Core-Commands';
			package: 'Versionner-Core-Announcements';
			package: 'Versionner-Tests-Core-Model';
			package: 'Versionner-OB-UI';
			package: 'Versionner-OB-UI-Commands';
			package: 'Versionner-Tests-Core-Commands';
			package: 'Versionner-Help';
			package: 'Versionner-Morphic-UI-Commands';
			package: 'Versionner-Morphic-UI-Widgets';
			package: 'Versionner-Morphic-UI-Browser';
			package: 'Versionner-Morphic-Tests';
			package: 'Versionner-OB-Tests';			
			package: 'Versionner-Cache';
			package: 'Versionner-GLM-Browser';
			package: 'Versionner-Tests-Resources'.
		spec group: 'default' with: #('Versionner-Cache' 'Versionner-Core-Announcements' 'Versionner-Core-Commands' 'Versionner-Core-Model' 'Versionner-GLM-Browser' 'Versionner-Help' 'Versionner-Morphic-Tests' 'Versionner-Morphic-UI-Browser' 'Versionner-Morphic-UI-Commands' 'Versionner-Morphic-UI-Widgets' 'Versionner-OB-Tests' 'Versionner-OB-UI' 'Versionner-OB-UI-Commands' 'Versionner-Tests-Core-Commands' 'Versionner-Tests-Core-Model' 'Versionner-Tests-Resources' ). ].
! !

!ConfigurationOfVersionner methodsFor: 'symbolic versions' stamp: 'JPSA 4/18/2012 16:48'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfVersionner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 3/27/2012 11:49'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfVersionner methodsFor: 'versions' stamp: 'JPSA 4/18/2012 16:48'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.1 :'.
		spec author: 'JPSA'.
		spec timestamp: '4/18/2012 16:48'.
		spec 
			package: 'Versionner-Core-Model' with: 'Versionner-Core-Model-JuanPabloSandovalAlcocer.10';
			package: 'Versionner-Core-Commands' with: 'Versionner-Core-Commands-JuanPabloSandovalAlcocer.12';
			package: 'Versionner-Core-Announcements' with: 'Versionner-Core-Announcements-JuanPabloSandovalAlcocer.4';
			package: 'Versionner-OB-UI' with: 'Versionner-OB-UI-JuanPabloSandovalAlcocer.10';
			package: 'Versionner-OB-UI-Commands' with: 'Versionner-OB-UI-Commands-JuanPabloSandovalAlcocer.3';
			package: 'Versionner-Cache' with: 'Versionner-Cache-JuanPabloSandovalAlcocer.7';
			package: 'Versionner-GLM-Browser' with: 'Versionner-GLM-Browser-JPSA.5';
			package: 'Versionner-Help' with: 'Versionner-Help-JuanPabloSandovalAlcocer.3';
			package: 'Versionner-Morphic-UI-Browser' with: 'Versionner-Morphic-UI-Browser-JuanPabloSandovalAlcocer.9';
			package: 'Versionner-Morphic-UI-Commands' with: 'Versionner-Morphic-UI-Commands-JuanPabloSandovalAlcocer.4';
			package: 'Versionner-Morphic-UI-Widgets' with: 'Versionner-Morphic-UI-Widgets-JuanPabloSandovalAlcocer.3';
			package: 'Versionner-Tests-Core-Commands' with: 'Versionner-Tests-Core-Commands-JuanPabloSandovalAlcocer.2';
			package: 'Versionner-OB-Tests' with: 'Versionner-OB-Tests-JuanPabloSandovalAlcocer.5';
			package: 'Versionner-Tests-Core-Model' with: 'Versionner-Tests-Core-Model-JuanPabloSandovalAlcocer.5';
			package: 'Versionner-Morphic-Tests' with: 'Versionner-Morphic-Tests-JuanPabloSandovalAlcocer.4';
			package: 'Versionner-Tests-Resources' with: 'Versionner-Tests-Resources-JuanPabloSandovalAlcocer.2'. ].
! !

!ConfigurationOfVersionner methodsFor: 'versions' stamp: 'JPSA 4/18/2012 16:48'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.1 :'.
		spec author: 'JPSA'.
		spec timestamp: '4/18/2012 16:48'.
		spec 
			package: 'Versionner-Core-Model' with: 'Versionner-Core-Model-JuanPabloSandovalAlcocer.10';
			package: 'Versionner-Core-Commands' with: 'Versionner-Core-Commands-JuanPabloSandovalAlcocer.12';
			package: 'Versionner-Core-Announcements' with: 'Versionner-Core-Announcements-JuanPabloSandovalAlcocer.4';
			package: 'Versionner-Tests-Core-Model' with: 'Versionner-Tests-Core-Model-JuanPabloSandovalAlcocer.5';
			package: 'Versionner-OB-UI' with: 'Versionner-OB-UI-JuanPabloSandovalAlcocer.10';
			package: 'Versionner-OB-UI-Commands' with: 'Versionner-OB-UI-Commands-JuanPabloSandovalAlcocer.3';
			package: 'Versionner-Tests-Core-Commands' with: 'Versionner-Tests-Core-Commands-JuanPabloSandovalAlcocer.2';
			package: 'Versionner-Help' with: 'Versionner-Help-JuanPabloSandovalAlcocer.3';
			package: 'Versionner-Morphic-UI-Commands' with: 'Versionner-Morphic-UI-Commands-JuanPabloSandovalAlcocer.4';
			package: 'Versionner-Morphic-UI-Widgets' with: 'Versionner-Morphic-UI-Widgets-JuanPabloSandovalAlcocer.3';
			package: 'Versionner-Morphic-UI-Browser' with: 'Versionner-Morphic-UI-Browser-JuanPabloSandovalAlcocer.9';
			package: 'Versionner-Morphic-Tests' with: 'Versionner-Morphic-Tests-JuanPabloSandovalAlcocer.4';
			package: 'Versionner-OB-Tests' with: 'Versionner-OB-Tests-JuanPabloSandovalAlcocer.5';
			package: 'Versionner-Cache' with: 'Versionner-Cache-JuanPabloSandovalAlcocer.7';
			package: 'Versionner-GLM-Browser' with: 'Versionner-GLM-Browser-JPSA.5';
			package: 'Versionner-Tests-Resources' with: 'Versionner-Tests-Resources-JuanPabloSandovalAlcocer.2'. ].
! !
